﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using ff14bot.Managers;

namespace GPPotGuyPlugin
{
    public partial class Gui : Form
    {

        private static IEnumerable<string> CPPotList()
        {
            return InventoryManager.FilledSlots.InventoryItems()
            .CPMedicineItems()
            .Select(x => x.Item.EnglishName + "(HQ: " + x.Item.IsHighQuality.ToString() + ")");
        }

        private static IEnumerable<string> GPPotList()
        {
            return InventoryManager.FilledSlots.InventoryItems()
            .GPMedicineItems()
            .Select(x => x.Item.EnglishName + "(HQ: " + x.Item.IsHighQuality.ToString() + ")");
        }

        public Gui()
        {
            InitializeComponent();

            var CPPots = CPPotList().ToList();
            CPPots.Insert(0, "None");
            comboBoxCP.DataSource = CPPots;

            /*
            comboBoxCP.DataSource =
                InventoryManager.FilledSlots.InventoryItems()
                    .CPMedicineItems()
                    .Select(x => x.Item.EnglishName + "(HQ: " + x.Item.IsHighQuality.ToString() + ")").ToList();
            comboBoxCP.Items.Add("None");*/

            if (Settings.Instance.CPMedicineName != null && comboBoxCP.Items.Contains(Settings.Instance.CPMedicineName))
            {
                comboBoxCP.SelectedItem = Settings.Instance.CPMedicineName;
            }
            else
            {
                comboBoxCP.SelectedItem = "None";
                Settings.Instance.CPMedicineName = null;
                Settings.Instance.Save();
            }
            /*
            if (
                InventoryManager.FilledSlots.InventoryItems()
                    .CPMedicineItems()
                    .Select(x => x.Item.EnglishName)
                    .Contains(Settings.Instance.CPMedicineName))
            {
                comboBoxCP.SelectedItem = Settings.Instance.CPMedicineName;
            }
            else
            {
                Settings.Instance.CPMedicineName = null;
                Settings.Instance.Save();
            }*/

            var GPPots = GPPotList().ToList();
            GPPots.Insert(0, "None");
            comboBoxGP.DataSource = GPPots;
            /*
            comboBoxGP.DataSource =
                InventoryManager.FilledSlots.InventoryItems()
                    .GPMedicineItems()
                    .Select(x => x.Item.EnglishName + "(HQ: " + x.Item.IsHighQuality.ToString() + ")").ToList();
            comboBoxGP.Items.Add("None");*/

            if (Settings.Instance.GPMedicineName != null && comboBoxGP.Items.Contains(Settings.Instance.GPMedicineName))
            {
                comboBoxGP.SelectedItem = Settings.Instance.GPMedicineName;
            }
            else
            {
                comboBoxGP.SelectedItem = "None";
                Settings.Instance.GPMedicineName = null;
                Settings.Instance.Save();
            }
            /*
            var GPMedicineName = InventoryManager.FilledSlots.InventoryItems()
                    .GPMedicineItems()
                    .FirstOrDefault(x => x.Item.EnglishName == (Settings.Instance.GPMedicineName));

            if (
                InventoryManager.FilledSlots.InventoryItems()
                    .GPMedicineItems()
                    .Select(x => x.Item.EnglishName)
                    .Contains(Settings.Instance.GPMedicineName))
            {
                comboBoxGP.SelectedValue = Settings.Instance.GPMedicineName;//GPMedicineName;
            }
            else
            {
                //comboBoxGP.SelectedValue = null;
                Settings.Instance.GPMedicineName = null;
                Settings.Instance.Save();
            }*/
        }

        private void comboBoxCP_SelectionChangeCommitted(object sender, EventArgs e)
        {
            Settings.Instance.CPMedicineName = comboBoxCP.SelectedValue.ToString();
            if (Settings.Instance.CPMedicineName == "None") { Settings.Instance.CPMedicineName = null; }
            Settings.Instance.Save();
        }

        private void comboBoxGP_SelectionChangeCommitted(object sender, EventArgs e)
        {
            Settings.Instance.GPMedicineName = comboBoxGP.SelectedValue.ToString();
            if (Settings.Instance.GPMedicineName == "None") { Settings.Instance.GPMedicineName = null; }
            Settings.Instance.Save();
        }

        private void checkBoxCP_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Instance.UseCPMedicine = checkBoxCP.Checked;
            Settings.Instance.Save();
        }

        private void checkBoxGP_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Instance.UseGPMedicine = checkBoxGP.Checked;
            Settings.Instance.Save();
        }

        private void CPThresholdUpDown_ValueChanged(object sender, EventArgs e)
        {
            Settings.Instance.CPThreshold = (float)CPThresholdUpDown.Value;
            Settings.Instance.Save();
        }

        private void GPThresholdUpDown_ValueChanged(object sender, EventArgs e)
        {
            Settings.Instance.GPThreshold = (float)GPThresholdUpDown.Value;
            Settings.Instance.Save();
        }

        private void comboBoxCP_DropDown(object sender, EventArgs e)
        {
            comboBoxCP.DataSource = null;
            var CPPots = CPPotList().ToList();
            CPPots.Insert(0, "None");
            comboBoxCP.DataSource = CPPots;
        }

        private void comboBoxGP_DropDown(object sender, EventArgs e)
        {
            comboBoxGP.DataSource = null;
            var GPPots = GPPotList().ToList();
            GPPots.Insert(0, "None");
            comboBoxGP.DataSource = GPPots;
        }
    }
}